/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.baselibs;


import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataElement;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDicomValue;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.commoninterface.ITransferSyntax;
import cdac.medinfo.sdk.dcm30_04.exceptions.ConditionFailedException;
import cdac.medinfo.sdk.dcm30_04.exceptions.InvalidItemException;
import cdac.medinfo.sdk.dcm30_04.exceptions.MandatoryMissingException;
import cdac.medinfo.sdk.dcm30_04.exceptions.ValidationException;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConstants;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;




/**
* This item class contains methods to validate, set and get the attributes of {@link RegistrationSequence}.
 */

public class RegistrationSequenceItem extends Item  
{
	


	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * This constructor creates the item and internal code sequence macro with default TransferSyntax 
	 */
	RegistrationSequenceItem()
	{
		super();
	}

	/**
	 * This constructor creates the item and internal code sequence macro with default TransferSyntax 
	 * and default DictionaryReader
	 * @param objITransferSyntax specifies the DICOM Standard defined TransfeSyntax
	 */
	RegistrationSequenceItem(ITransferSyntax objITransferSyntax)
	{
		super(objITransferSyntax);
	}

	/**
	 * This constructor creates RegistrationSequenceItem with specified TransferSyntax and
	 * specified DictionaryReader.
	 * @param objTransferSyntax specifies the DICOM Standard defined TransfeSyntax.
	 * @param objDictionaryReader specifies the DICOM Dictionary reader to be used.
	 */
	RegistrationSequenceItem(ITransferSyntax objTransferSyntax, IDictionaryReader objDictionaryReader)
	{
		super(objTransferSyntax,objDictionaryReader);
	}

	/**
	 * Validates all the attributes in RegistrationSequenceItem that are present in the DataSet
	 * @return boolean - Success -true, Failure - false
	 * @throws InvalidItemException throws InvalidItemException If Mandatory or Conditional element fails.
	 */
	public boolean validateForModule() throws InvalidItemException
	{
		try{
			if(!contains(0x0070,0x0309))
				throw new MandatoryMissingException("0070,0309");
			if(!contains(0x0008,0x1140)&&!contains(0x0020,0x0052))
				throw new ConditionFailedException("0020,0052 or 0008,1140 Required if Referenced Image Sequence (0008,1140) or (0008,1140) is absent respectively . May be present otherwise.");

		}
		catch(MandatoryMissingException me)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(me.getMessage());
			}
			throw new ValidationException(this.getClass().getSimpleName(),me);
		}
		catch( ConditionFailedException me)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(me.getMessage());
			}
			throw new ValidationException(this.getClass().getSimpleName(),me);
		}
		return true;
	}


	/**
	 * Sets attribute identifies a Frame of Reference that may or may not be an image set.
	 * @param StrFrameofReferenceUID String identifies Frame of Reference 
	 */	
	public void setFrameofReferenceUID(String StrFrameofReferenceUID)
	{
		/*Accept Frame of Reference in String 
		 * Read the Transfer Syntax and check to create ImplicitDE or ExplicitDE .
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Hash Map
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0020,0x0052,StrFrameofReferenceUID,objIDictionaryReader);
		else
			objIDataElement = new ExplicitDE(0x0020,0x0052, DicomConstants.DCM_DT_UI,StrFrameofReferenceUID);

		addDataElement(objIDataElement);
	}

	/**
	 * Return  attribute identifies a Frame of Reference that may or may not be an image set.
	 * @return String - identifies Frame of Reference 
	 */
	public String getFrameofReferenceUID()
	{
		Object objValue = getValue(0x0020,0x0052);
		if(objValue != null)
			return objValue.toString();
		return null;
	}

	/**
	 * Retrieves pre-initialized object of Referenced Image Sequence.If the module contains the sequence object
	 * it returns the same otherwise it creates the sequence adds to the module with proper initialization
	 * and then returns the object of sequence
	 * @return ReferencedImageSequence - instance of Referenced Image Sequence
	 */
	public ReferencedImageSequence getReferencedImageSequence()
	{
		ReferencedImageSequence objReferencedImageSequence = null;
		IDataElement objIDataElement =  getDataForTag(0x0008,0x1140);
		if(objIDataElement != null)
		{
			IDicomValue objIDicomValue = objIDataElement.getDicomValue();
			if(objIDicomValue != null)
				objReferencedImageSequence = (ReferencedImageSequence)objIDicomValue;
		}
		else
		{
			DicomV3Factory objDicomV3Factory = DicomV3Factory.createInstance();
			int iVRTransferSyntax = objITransferSyntax.getVRTransferSyntax();
			objIDataElement = null;
			objReferencedImageSequence = (ReferencedImageSequence)objDicomV3Factory.createSequence(0x0008,0x1140, objITransferSyntax, objIDictionaryReader);

			if(iVRTransferSyntax == DicomConstants.DCM_VR_IMPLICIT)
				objIDataElement = new ImplicitDE(0x0008,0x1140, objReferencedImageSequence.getValue(),objIDictionaryReader);
			else
				objIDataElement = new ExplicitDE(0x0008,0x1140, DicomConstants.DCM_DT_SQ, objReferencedImageSequence.getValue());
			objIDataElement.setTransferSyntax(objITransferSyntax);
			if(objIDataElement != null)
				addDataElement(objIDataElement);
		}
		return objReferencedImageSequence;
	}

	/**
	 * Retrieves pre-initialized object of Matrix Registration Sequence.If the module contains the sequence object
	 * it returns the same otherwise it creates the sequence adds to the module with proper initialization
	 * and then returns the object of sequence
	 * @return MatrixRegistrationSequence - instance of Matrix Registration Sequence
	 */
	public MatrixRegistrationSequence getMatrixRegistrationSequence()
	{
		MatrixRegistrationSequence objMatrixRegistrationSequence = null;
		IDataElement objIDataElement =  getDataForTag(0x0070,0x0309);
		if(objIDataElement != null)
		{
			IDicomValue objIDicomValue = objIDataElement.getDicomValue();
			if(objIDicomValue != null)
				objMatrixRegistrationSequence = (MatrixRegistrationSequence)objIDicomValue;
		}
		else
		{
			DicomV3Factory objDicomV3Factory = DicomV3Factory.createInstance();
			int iVRTransferSyntax = objITransferSyntax.getVRTransferSyntax();
			objIDataElement = null;
			objMatrixRegistrationSequence = (MatrixRegistrationSequence)objDicomV3Factory.createSequence(0x0070,0x0309, objITransferSyntax, objIDictionaryReader);

			if(iVRTransferSyntax == DicomConstants.DCM_VR_IMPLICIT)
				objIDataElement = new ImplicitDE(0x0070,0x0309, objMatrixRegistrationSequence.getValue(),objIDictionaryReader);
			else
				objIDataElement = new ExplicitDE(0x0070,0x0309, DicomConstants.DCM_DT_SQ, objMatrixRegistrationSequence.getValue());
			objIDataElement.setTransferSyntax(objITransferSyntax);
			if(objIDataElement != null)
				addDataElement(objIDataElement);
		}
		return objMatrixRegistrationSequence;
	}

	/**
	 * Retrieves pre-initialized object of Used Fiducials Sequence.If the module contains the sequence object
	 * it returns the same otherwise it creates the sequence adds to the module with proper initialization
	 * and then returns the object of sequence
	 * @return UsedFiducialsSequence - instance of Used Fiducials Sequence 
	 */
	public UsedFiducialsSequence getUsedFiducialsSequence()
	{
		UsedFiducialsSequence objUsedFiducialsSequence = null;
		IDataElement objIDataElement =  getDataForTag(0x0070,0x0314);
		if(objIDataElement != null)
		{
			IDicomValue objIDicomValue = objIDataElement.getDicomValue();
			if(objIDicomValue != null)
				objUsedFiducialsSequence = (UsedFiducialsSequence)objIDicomValue;
		}
		else
		{
			DicomV3Factory objDicomV3Factory = DicomV3Factory.createInstance();
			int iVRTransferSyntax = objITransferSyntax.getVRTransferSyntax();
			objIDataElement = null;
			objUsedFiducialsSequence = (UsedFiducialsSequence)objDicomV3Factory.createSequence(0x0070,0x0314, objITransferSyntax, objIDictionaryReader);

			if(iVRTransferSyntax == DicomConstants.DCM_VR_IMPLICIT)
				objIDataElement = new ImplicitDE(0x0070,0x0314, objUsedFiducialsSequence.getValue(),objIDictionaryReader);
			else
				objIDataElement = new ExplicitDE(0x0070,0x0314, DicomConstants.DCM_DT_SQ, objUsedFiducialsSequence.getValue());
			objIDataElement.setTransferSyntax(objITransferSyntax);
			if(objIDataElement != null)
				addDataElement(objIDataElement);
		}
		return objUsedFiducialsSequence;
	}
}
